/*
 * Copyright © 2021-2021. Kingsrook LLC <contact@kingsrook.com>.  All Rights Reserved.
 */

package com.kingsrook.qqq.backend.core.model.actions.insert;


import java.util.List;
import com.kingsrook.qqq.backend.core.model.actions.AbstractQTableRequest;
import com.kingsrook.qqq.backend.core.model.data.QRecord;
import com.kingsrook.qqq.backend.core.model.metadata.QInstance;


/*******************************************************************************
 ** Request data handler for the Insert action
 **
 *******************************************************************************/
public class InsertRequest extends AbstractQTableRequest
{
   private List<QRecord> records;



   /*******************************************************************************
    **
    *******************************************************************************/
   public InsertRequest()
   {
   }



   /*******************************************************************************
    **
    *******************************************************************************/
   public InsertRequest(QInstance instance)
   {
      super(instance);
   }



   /*******************************************************************************
    ** Getter for records
    **
    *******************************************************************************/
   public List<QRecord> getRecords()
   {
      return records;
   }



   /*******************************************************************************
    ** Setter for records
    **
    *******************************************************************************/
   public void setRecords(List<QRecord> records)
   {
      this.records = records;
   }
}
